summaryrefslogtreecommitdiffstats
path: root/src/grep/tests/backref-alt
diff options
context:
space:
mode:
Diffstat (limited to 'src/grep/tests/backref-alt')
-rwxr-xr-xsrc/grep/tests/backref-alt34
1 files changed, 34 insertions, 0 deletions
diff --git a/src/grep/tests/backref-alt b/src/grep/tests/backref-alt
new file mode 100755
index 0000000..986621b
--- /dev/null
+++ b/src/grep/tests/backref-alt
@@ -0,0 +1,34 @@
+#! /bin/sh
+# Test for a bug in glibc's regex code as of 2015-09-19.
+#
+# Copyright 2015-2021 Free Software Foundation, Inc.
+#
+# Copying and distribution of this file, with or without modification,
+# are permitted in any medium without royalty provided the copyright
+# notice and this notice are preserved.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+
+echo aa > in || framework_failure_
+
+fail=0
+
+grep -E 'b|(.)b|\1|b' in >out
+status=$?
+# POSIX isn't clear whether this regular expression should be invalid,
+# (because the \1 is out of range for REs that could precede it)
+# or valid but \1 should not match. Allow either interpretation.
+test $status -eq 2 || test $status -eq 1 || fail=1
+
+grep -E '0|()0|\1|0' in >out
+status=$?
+test $status -eq 2 || test $status -eq 1 || fail=1
+
+# This test is a reduced version of the one in Bug#27838.
+# It triggers this glibc assertion failure:
+# grep: regexec.c:1342: pop_fail_stack: Assertion `num >= 0' failed.
+LC_ALL=C grep -E '(()x)|\2' in > out
+status=$?
+test $status -eq 2 || test $status -eq 1 || fail=1
+
+Exit $fail